package cn.com.infosec.jce.provider;

import java.security.InvalidAlgorithmParameterException;
import java.security.cert.CRL;
import java.security.cert.CRLSelector;
import java.security.cert.CertSelector;
import java.security.cert.CertStoreParameters;
import java.security.cert.CertStoreSpi;
import java.security.cert.Certificate;
import java.security.cert.CollectionCertStoreParameters;
import java.util.ArrayList;
import java.util.Collection;
import java.util.Iterator;

public class CertStoreCollectionSpi extends CertStoreSpi {
   private CollectionCertStoreParameters params;

   public CertStoreCollectionSpi(CertStoreParameters params) {
      super(params);
      if (params instanceof CollectionCertStoreParameters) {
         this.params = (CollectionCertStoreParameters)params;
      } else {
         throw new InvalidAlgorithmParameterException("cn.com.infosec.jce.provider.CertStoreCollectionSpi: parameter must be a CollectionCertStoreParameters object\n" + params.toString());
      }
   }

   public Collection engineGetCertificates(CertSelector selector) {
      CertStoreCollectionSpi var10001 = this;
      ArrayList var4;
      var4 = new ArrayList.<init>();
      Iterator var2 = var10001.params.getCollection().iterator();
      if (selector == null) {
         while(var2.hasNext()) {
            Object selector1;
            if ((selector1 = var2.next()) instanceof Certificate) {
               var4.add(selector1);
            }
         }
      } else {
         while(var2.hasNext()) {
            Object var3;
            if ((var3 = var2.next()) instanceof Certificate && selector.match((Certificate)var3)) {
               var4.add(var3);
            }
         }
      }

      return var4;
   }

   public Collection engineGetCRLs(CRLSelector selector) {
      CertStoreCollectionSpi var10001 = this;
      ArrayList var4;
      var4 = new ArrayList.<init>();
      Iterator var2 = var10001.params.getCollection().iterator();
      if (selector == null) {
         while(var2.hasNext()) {
            Object selector1;
            if ((selector1 = var2.next()) instanceof CRL) {
               var4.add(selector1);
            }
         }
      } else {
         while(var2.hasNext()) {
            Object var3;
            if ((var3 = var2.next()) instanceof CRL && selector.match((CRL)var3)) {
               var4.add(var3);
            }
         }
      }

      return var4;
   }
}
